function [modifiedImage, inputFFT, outputFFT] = HLpassFilter(im, s, lowHIGH)
%% artefact removal using Fourier transform
% input:
%  im               - input image
%  s                - size (perimeter) of the high pass filter
% output
%  modifiedImage    - modifed image
%  inputFFT         - frequency domain of original image (for showing in gui)
%  outputFFT        - frequency domain of modified image (for showing in gui)
% The task is to implement high pass and low pass filter on the image in Frequency domain
% The mask for filter need to be created and appplied in Frequency domain.
% Look out for shift in display of Frequency domain.

% Compute the radius of the filter (to round it to an even number)
if s > 3
    filterRadius = floor(s/4) * 2;
else
    filterRadius = 1;
end
filterSize = filterRadius * 2 + 1;

%% IMPLEMENT ME
% Remove the next three lines after you implement your code
inputFFT = zeros(1);
outputFFT = zeros(1);
modifiedImage = im;

% Apply Fourier transform on input image

% Create the mask of the size of the input image.
if strcmpi(lowHIGH, 'low')
    % do something if the filter should be low-pass
elseif strcmpi(lowHIGH, 'high')
    % do something if the filter should be high-pass
end

% Apply mask in the fourier transform

% Perform inverse fourier transform on the outputFFT and store the results
% as modifiedImage



% This will modify the FFT images so that they can by displayed as an image
inputFFT = log(abs(fftshift(inputFFT)));
outputFFT = log(abs(fftshift(outputFFT)));
